unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Str2: TStringGrid;
    StatusBar1: TStatusBar;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Str2Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
type
Tstroc=record
   name:string;
   Value:char;
end;
var
ch:array of Tstroc;
chCount:integer;

Function AddCh(Name:string;Value:Char):integer;
begin
 chCount:=chCount+1;
 setlength(ch,chCount);
 ch[chCount-1].name:=name;
 ch[chCount-1].value:=value;
end;

Procedure Init;
begin
AddCh('','');
AddCh('','[');
AddCh('',']');
AddCh('','(');
AddCh('',')');
AddCh('','{');
AddCh('','}');
AddCh('',':');
AddCh('',',');
AddCh('','');
AddCh('','');
AddCh('','');
AddCh(' ','!');
AddCh('','.');
AddCh('','-');
AddCh('','');

AddCh('','');
AddCh('','');
AddCh('','');
AddCh('','');
AddCh('','');
AddCh('',#39);
AddCh('  ',';');
AddCh(' ','/');
AddCh('  	','/');
//
AddCh('',#32);
AddCh('','');
// 

AddCh('','&');
AddCh(' at','@');
AddCh('','*');
AddCh('  ','\');
AddCh(' ','');
AddCh('','^');
AddCh('   ','');
AddCh(' ','');
AddCh('','');
AddCh('','');
AddCh('','');
AddCh('//','#');
AddCh(' ','');
AddCh('','%');
AddCh('','');
AddCh('','');
AddCh('    ','');
AddCh(' ','');
AddCh('','~');
AddCh('  ','');
AddCh('','_');
AddCh(' ','|');
AddCh(' ','');
end;
Function IntToBin(IValue : Int64; NumBits : word = 64) : string;
var RetVar : string;
    i,ILen : byte;
begin
RetVar := '';

case NumBits of
      32 : IValue := dword(IValue);
      16 : IValue := word(IValue);
      8  : IValue := byte(IValue);
end;

while IValue <> 0 do begin
    Retvar := char(48 + (IValue and 1)) + RetVar;
    IValue := IValue shr 1;
end;

if RetVar = '' then Retvar := '0';
Result := RetVar;
end;

Function GetListFromCH:string;
var x:integer;
    s2:string;
begin
  s2:='';
  for x:=0 to chCount-1 do begin
    s2:=s2+ch[x].name+'="'+ch[x].Value+'"'+#13+#10;
  end;
  result:=s2;
end;
Function GetCharCaption(chvalue:char):string;
var x:integer;
begin
 for X:=0 to chCount-1 do begin
   if ch[x].Value=chvalue then begin result:=ch[x].name; exit; end;
 end;
 result:=chvalue;
end;
procedure TForm1.FormCreate(Sender: TObject);
var i,x,y:integer;
begin
Init;
Y:=1;x:=0;
form1.Str2.cells[0,0]:='';
form1.Str2.cells[1,0]:='10/16';
form1.Str2.cells[2,0]:='2- ';
form1.Str2.cells[3,0]:='';
form1.Str2.cells[4,0]:='10/16';
form1.Str2.cells[5,0]:='2- ';
form1.Str2.cells[6,0]:='';
form1.Str2.cells[7,0]:='10/16';
form1.Str2.cells[8,0]:='2- ';
form1.Str2.cells[9,0]:='';
form1.Str2.cells[10,0]:='10/16';
form1.Str2.cells[11,0]:='2- ';


  for i:=1 to 255 do begin
    if chr(i)='"' then form1.Str2.Cells[x,y]:='"'
    else
    form1.Str2.Cells[x,y]:='"'+chr(i)+'"';
    form1.Str2.Cells[x+1,y]:=inttostr(i)+'/'+inttohex(i,2);
    form1.Str2.Cells[x+2,y]:=IntToBin(i);
    x:=x+3;
    if x>10 then begin
    y:=y+1;
    x:=0;
    end;

  end;
end;

procedure TForm1.Str2Click(Sender: TObject);
    var S:string;
begin
   s:=form1.Str2.Cells[form1.Str2.col,form1.Str2.row];
   if s<>'' then
   if s[1]='"' then
   if s<>'"' then
   form1.StatusBar1.Panels[0].Text:=GetCharCaption(s[2])
   else form1.StatusBar1.Panels[0].Text:='';
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
var x,y:integer;
begin
for y:=1 to form1.Str2.rowCount-1 do
for x:=0 to form1.Str2.ColCount-1 do
   if form1.Str2.Cells[x,y]='"'+key+'"' then begin
    form1.Str2.Col:=x;
    form1.Str2.Row:=y;

   end;


end;


procedure TForm1.Edit1Change(Sender: TObject);
var x:integer;
    s2:string;
begin

  s2:=' '; //  
  edit2.Text:='';
  for X:=1 to length(form1.Edit1.text) do begin
   edit2.Text:=edit2.Text+s2+inttohex(ord(form1.Edit1.text[x]),2)
  end;
  if edit1.text<>'' then begin
  if edit1.text[1]='$' then begin if trystrtoint(edit1.text,x) then edit3.Text:=inttostr(x); end
  else
  if trystrtoint(edit1.text,x) then edit3.Text:=inttohex(x,2);
  end;
end;

end.
